package controller

import (
	"fmt"
	"github.com/gofiber/fiber/v2"
	"goblog/dal"
	"goblog/jwt"
	"goblog/view"
)

func Posts(c *fiber.Ctx) error {
	token, err := jwt.GetJwt(c)
	_ = token
	if err != nil {
		return c.JSON(view.UserProfileResponse{
			BaseResponse: view.BaseResponse{
				Success: false,
				Message: "Not logged in",
			},
		})
	}

	posts, err := dal.GetPosts(token.UserId)
	if err != nil {
		return c.JSON(view.UserProfileResponse{
			BaseResponse: view.BaseResponse{
				Success: false,
				Message: fmt.Sprintf("Failed to get posts: %v", err),
			},
		})
	}

	return c.JSON(view.PostsResponse{
		BaseResponse: view.BaseResponse{
			Success: true,
			Message: "",
		},
		Posts: posts,
	})
}
