package controller

import (
	"fmt"
	"github.com/gofiber/fiber/v2"
	"goblog/dal"
	"goblog/view"
	"log"
)

func Register(c *fiber.Ctx) error {
	var req view.RegisterRequest

	err := c.BodyParser(&req)
	if err != nil {
		return c.JSON(view.RegisterResponse{
			BaseResponse: view.BaseResponse{
				Success: false,
				Message: "Invalid request",
			},
		})
	}

	log.Println("Register request: ", req)

	uid, err := dal.CreateUser(req.Username, req.Password)
	if err != nil {
		return c.JSON(view.RegisterResponse{
			BaseResponse: view.BaseResponse{
				Success: false,
				Message: fmt.Sprintf("Failed to create user: %v", err),
			},
		})
	}

	return c.JSON(view.RegisterResponse{
		UserId: uid,
		BaseResponse: view.BaseResponse{
			Success: true,
			Message: "",
		},
	})
}
